unit ImgDraw;

interface

uses
  GR32, GR32_Image, GR32_BitmapUtils;

type
  TToolMode = (
    _select,_move,_erase,_fill,_brush,_pencil,
    _rect,_fillrect,_roundrect,_fillroundrect,_ellipse,_fillellipse,
    _text,_picker,_line,_contline);

  procedure ImageDraw(Bitmap: TBitmap32; StartX,StartY,EndX,EndY,OldX,OldY: integer; Color: TColor32; Mode: TToolMode);

implementation

procedure ImageDraw(Bitmap: TBitmap32; StartX,StartY,EndX,EndY,OldX,OldY: integer; Color: TColor32; Mode: TToolMode);
var
  Rx,Ry: integer;

  procedure Ellipse(X,Y: integer; StAngle,EndAngle: word; XRadius,YRadius: word; AColor: TColor32);
  VAR
    oldx,oldy,dx,dy:Integer;
    deg:Integer;
    function Radian(Angle:Word):Real; begin Result:=Pi*Angle/180; end;
  BEGIN
    if StAngle>EndAngle then
      begin
        deg:=StAngle;
        StAngle:=EndAngle;
        EndAngle:=Deg;
      end;
    deg:=StAngle;
    dx:=round(XRadius*cos (Radian(deg)));
    dy:=round(YRadius*sin (Radian(deg)));
    oldx:=dx;
    oldY:=dy;
    repeat
      dx:=round(XRadius*COS (Radian(deg)));
      dy:=round(YRadius*sin (Radian(deg)));
      Bitmap.LineFS(x+dx,y-dy,x+oldx,y-oldy,AColor);
      oldx:=dx;
      oldY:=dy;
      deg:=deg+1;
    until (deg>EndAngle);
  END;

begin

  if not (Mode in [_pencil]) then Bitmap.Clear($00FFFFFF);

  case Mode of
    _pencil:
            begin
              Bitmap.Line  (OldX,OldY,EndX,EndY,Color,true);
              //Bitmap.LineFS(OldX,OldY,EndX,EndY,Color,true);
            end;
    _line :
            begin
              Bitmap.Line  (StartX,StartY,EndX,EndY,Color,true);
              //Bitmap.LineFS(StartX,StartY,EndX,EndY,Color,true);
            end;

    _ellipse :
            begin
              //Ellipse(EDx,EDy,0,360,Abs(EDx-Sdx),Abs(EDy-Sdy),fActiveColor);
              //Bitmap.PenColor:=Color;
              //Circle(Bitmap,StartX,StartY,Abs(EndX-StartX),Abs(EndY-StartY));
              Rx:=Abs(EndX-StartX) div 2;
              Ry:=Abs(EndY-StartY) div 2;
              Ellipse(EndX-Rx,EndY-Ry,0,  90, Rx,Ry+(ord(Abs(EndY-StartY) mod 2<>0)),Color);
              Ellipse(EndX-Rx,EndY-Ry,90, 180,Rx+(ord(Abs(EndX-StartX) mod 2<>0)),Ry+(ord(Abs(EndY-StartY) mod 2<>0)),Color);
              Ellipse(EndX-Rx,EndY-Ry,180,270,Rx+(ord(Abs(EndX-StartX) mod 2<>0)),Ry,Color);
              Ellipse(EndX-Rx,EndY-Ry,270,360,Rx,Ry,Color);
            end;
    _rect   :
            begin
              Bitmap.Line(StartX,StartY,EndX,StartY,Color,true);
              Bitmap.Line(StartX,StartY,StartX,EndY,Color,true);
              Bitmap.Line(StartX,EndY,EndX,EndY,Color,true);
              Bitmap.Line(EndX,StartY,EndX,EndY,Color,true);
            end;
  end;

end;

end.
